<template>
	<div class="minicart-item">
		<div class="minicart-item__row">
			<div class="minicart-item__col minicart-item__col--image">
				<div class="minicart-item__image-wrapper">
					<img
						class="minicart-item__image"
						:src="item.image.src | img_url('108x')"
						:alt="item.image.alt"
						v-if="item.image"
					/>
				</div>
			</div>

			<div class="minicart-item__col minicart-item__col--content">
				<div class="minicart-item__content">
					<div class="minicart-item__actions">
						<button
							type="button"
							class="minicart-item__action"
							@click="removeItem({
								key: item.key
							})"

						>
							<span class="visually-hidden">
								{{ 'cart.product.remove' | t({ product: item.title }) }}
							</span>

							<IconRemove/>
						</button>
					</div>

					<a :href="item.url" class="minicart-item__title">
						{{ item.title }}
					</a>

					<div class="minicart-item__options" v-if="item.options_with_values.length">
						<p class="minicart-item__option" v-for="option in item.options_with_values">
							{{ option.name }}: {{ option.value }}
						</p>
					</div>

					<div class="minicart-item__options minicart-item__options--properties" v-if="item.filteredProperties.length">
						<p class="minicart-item__option minicart-item__option--property" v-for="(property, key) in item.filteredProperties" :key="key">
							{{ key }}: {{ property }}
						</p>
					</div>

					<div class="minicart-item__quantity-selector">
						<div class="quantity-selector minicart-item__quantity-selector">
							<button
								type="button"
								class="quantity-selector__button minicart-item__quantity-selector-button"
								@click="changeQuantity({
									key: item.key,
									quantity: item.quantity - 1
								})"
							>
								<span class="visually-hidden">
									{{ 'sections.cart.product.quantity.decrease' | t({ product: item.title }) }}
								</span>

								<IconMinus/>
							</button>

							<input
								type="number"
								class="quantity-selector__input minicart-item__quantity-selector-input"
								v-model.number.lazy="item.quantity"
								@change="changeQuantity({
									key: item.key,
									quantity: item.quantity
								})"
							/>

							<button
								type="button"
								class="quantity-selector__button minicart-item__quantity-selector-button"
								@click="changeQuantity({
									key: item.key,
									quantity: item.quantity + 1
								})"
							>
								<span class="visually-hidden">
									{{ 'sections.cart.product.quantity.increase' | t({ product: item.title }) }}
								</span>

								<IconPlus/>
							</button>
						</div>

						<div class="minicart-item__price">
							<p class="minicart-item__price-value">
								{{ item.final_line_price | money }}
							</p>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import {
	createNamespacedHelpers
} from 'vuex';

import IconPlus from './../../../../icons/icon-plus.svg';
import IconMinus from './../../../../icons/icon-minus.svg';
import IconRemove from './../../../../icons/icon-remove.svg';

const { mapState, mapActions, mapGetters } = createNamespacedHelpers("cart");

import {
	ACTION_REMOVE_ITEM,
	ACTION_CHANGE_QUANTITY,
	ACTION_SAVE_FOR_LATER
} from '../../store/cart/cart';

export default {
	name: 'MinicartProduct',
	props: {
		item: {
			type: Object,
			required: true
		}
	},
	methods: {
		...mapActions([
			ACTION_REMOVE_ITEM,
			ACTION_CHANGE_QUANTITY,
			ACTION_SAVE_FOR_LATER
		])
	},
	components: {
		IconPlus,
		IconMinus,
		IconRemove
	}
}
</script>
